<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: melon::kernel::KernelCompositeAdd&lt; T, V &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('classmelon_1_1kernel_1_1_kernel_composite_add.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classmelon_1_1kernel_1_1_kernel_composite_add-members.html">List of all members</a>  </div>
  <div class="headertitle"><div class="title">melon::kernel::KernelCompositeAdd&lt; T, V &gt; Class Template Reference</div></div>
</div><!--header-->
<div class="contents">

<p>Composite kernel which on evaluation adds the evaluation results of its subkernels.  
 <a href="#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="kernel_8h_source.html">kernel.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for melon::kernel::KernelCompositeAdd&lt; T, V &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classmelon_1_1kernel_1_1_kernel_composite_add.png" usemap="#melon::kernel::KernelCompositeAdd_3C_20T_2C_20V_20_3E_map" alt=""/>
  <map id="melon::kernel::KernelCompositeAdd_3C_20T_2C_20V_20_3E_map" name="melon::kernel::KernelCompositeAdd_3C_20T_2C_20V_20_3E_map">
<area href="classmelon_1_1kernel_1_1_kernel.html" title="Abstract parent class for kernel implementations." alt="melon::kernel::Kernel&lt; T, V &gt;" shape="rect" coords="0,0,259,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pub-methods" name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a13bb991f5bad35ed9e0601cae676db99" id="r_a13bb991f5bad35ed9e0601cae676db99"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">void</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a13bb991f5bad35ed9e0601cae676db99">add</a> (std::shared_ptr&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; &gt; kernel)</td></tr>
<tr class="memdesc:a13bb991f5bad35ed9e0601cae676db99"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for adding another subkernel to the composite kernel.  <br /></td></tr>
<tr class="separator:a13bb991f5bad35ed9e0601cae676db99"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2af41f4a028e420edaca18501bf10a58" id="r_a2af41f4a028e420edaca18501bf10a58"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a2af41f4a028e420edaca18501bf10a58">evaluate_kernel</a> (std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> &gt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">x1</a>, std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">x2</a>)</td></tr>
<tr class="memdesc:a2af41f4a028e420edaca18501bf10a58"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for evalualting the kernel.  <br /></td></tr>
<tr class="separator:a2af41f4a028e420edaca18501bf10a58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classmelon_1_1kernel_1_1_kernel"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pub_methods_classmelon_1_1kernel_1_1_kernel')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">melon::kernel::Kernel&lt; T, V &gt;</a></td></tr>
<tr class="memitem:a723ab0686bbb045ff401220d51f72c2a inherit pub_methods_classmelon_1_1kernel_1_1_kernel" id="r_a723ab0686bbb045ff401220d51f72c2a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">virtual</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1kernel_1_1_kernel.html#a723ab0686bbb045ff401220d51f72c2a">~Kernel</a> ()=<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">default</a></td></tr>
<tr class="memdesc:a723ab0686bbb045ff401220d51f72c2a inherit pub_methods_classmelon_1_1kernel_1_1_kernel"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <br /></td></tr>
<tr class="separator:a723ab0686bbb045ff401220d51f72c2a inherit pub_methods_classmelon_1_1kernel_1_1_kernel"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-attribs" name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a252d76caee37fdbc77312bb099a04760" id="r_a252d76caee37fdbc77312bb099a04760"><td class="memItemLeft" align="right" valign="top">std::vector&lt; std::shared_ptr&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a252d76caee37fdbc77312bb099a04760">children</a></td></tr>
<tr class="separator:a252d76caee37fdbc77312bb099a04760"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="inherited" name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classmelon_1_1kernel_1_1_kernel"><td colspan="2" onclick="javascript:dynsection.toggleInherit('pub_types_classmelon_1_1kernel_1_1_kernel')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">melon::kernel::Kernel&lt; T, V &gt;</a></td></tr>
<tr class="memitem:afc65772b466950a64138b8914d44a0b1 inherit pub_types_classmelon_1_1kernel_1_1_kernel" id="r_afc65772b466950a64138b8914d44a0b1"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">using</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> = <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">decltype</a>(std::declval&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>&gt;() + std::declval&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a>&gt;())</td></tr>
<tr class="separator:afc65772b466950a64138b8914d44a0b1 inherit pub_types_classmelon_1_1kernel_1_1_kernel"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><div class="compoundTemplParams">template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a>&gt;<br />
class melon::kernel::KernelCompositeAdd&lt; T, V &gt;</div><p>Composite kernel which on evaluation adds the evaluation results of its subkernels. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a13bb991f5bad35ed9e0601cae676db99" name="a13bb991f5bad35ed9e0601cae676db99"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13bb991f5bad35ed9e0601cae676db99">&#9670;&#160;</a></span>add()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> , <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">void</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_composite_add.html">melon::kernel::KernelCompositeAdd</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;::add </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; &gt;</td>          <td class="paramname"><span class="paramname"><em>kernel</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function for adding another subkernel to the composite kernel. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">kernel</td><td>is the subkernel to be added </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2af41f4a028e420edaca18501bf10a58" name="a2af41f4a028e420edaca18501bf10a58"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2af41f4a028e420edaca18501bf10a58">&#9670;&#160;</a></span>evaluate_kernel()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> , <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classmelon_1_1kernel_1_1_kernel.html#afc65772b466950a64138b8914d44a0b1">RET</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_composite_add.html">melon::kernel::KernelCompositeAdd</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;::evaluate_kernel </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> &gt;</td>          <td class="paramname"><span class="paramname"><em>x1</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;</td>          <td class="paramname"><span class="paramname"><em>x2</em></span>&#160;)</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Function for evalualting the kernel. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">x1</td><td>is a vector containing the first point</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">x2</td><td>is a vector containing the second point</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns the result of the kernel evaluation </dd></dl>

<p>Implements <a class="el" href="classmelon_1_1kernel_1_1_kernel.html#a8ec36af697437b1a9b6ff84efb237e14">melon::kernel::Kernel&lt; T, V &gt;</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a252d76caee37fdbc77312bb099a04760" name="a252d76caee37fdbc77312bb099a04760"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a252d76caee37fdbc77312bb099a04760">&#9670;&#160;</a></span>children</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a> , <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">typename</a> <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;std::shared_ptr&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel.html">Kernel</a>&lt;<a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a>&gt; &gt; &gt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_composite_add.html">melon::kernel::KernelCompositeAdd</a>&lt; <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">T</a>, <a class="el" href="classmelon_1_1kernel_1_1_kernel_r_b_f.html">V</a> &gt;::children</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Vector containing the subkernels </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>C:/Data/Git/MeLOn/common/inc/<a class="el" href="kernel_8h_source.html">kernel.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacemelon.html">melon</a></li><li class="navelem"><a class="el" href="namespacemelon_1_1kernel.html">kernel</a></li><li class="navelem"><a class="el" href="classmelon_1_1kernel_1_1_kernel_composite_add.html">KernelCompositeAdd</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
